<?php
/* config */
$sys='nix'; //OS: set 'win' for windows and 'nix' for Linux/Unix
$acceptLang=array('en'); // the array of accepted languages
$dict_path='C:/Program Files (x86)/aspell/dict/'; //Win 32 only! path to pspell/aspell dictionaries
$dictAr=array('en'=>'en-only.rws'); //Win 32 only! pspell/aspell dictionary filenames
$doNotCheck='/[0-9\W]/'; //regular expression: define all characters you don't want to check here
/* eof config */

include '../setup_options.php';

if(isset($_POST['spellLang']) && in_array($_POST['spellLang'],$acceptLang)){
	$spellLang=$_POST['spellLang'];
	setlocale(LC_ALL,$spellLang.'_'.strtoupper($spellLang));
}
else $spellLang='';

if(isset($_GET['setlang'])) $setlang=$_GET['setlang'];
elseif(isset($_POST['setlang'])) $setlang=$_POST['setlang'];
else $setlang='';

if($setlang!='' && file_exists($pathToFiles."lang/{$setlang}.php") && $setlang=str_replace(array('.','/','\\'),'',$setlang)) $lang=$setlang;

$fName=$pathToFiles.'lang/mspell_'.$lang.'.php';
if(file_exists($fName)) include($fName); else include($pathToFiles.'lang/mspell_eng.php');

?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html>
<head><title>mSpell :: miniBB Spell Checker</title>
<link rel="stylesheet" href="<?php echo $main_url ?>/bb_<?php echo $skin ?>_style.css" type="text/css" />
<style type="text/css">
<!--
table.spellTable{
margin: 1px 1px 1px 1px;
border: 0px;
width: 99%;
height: 100%;
}
.inputButton{
margin-bottom: 4px;
}
.txtSm{
font-weight: bold;
}
-->
</style>
<?php
if(!isset($_POST['spellText'])){
?>
</head>
<body class="gbody popUp" style="margin:0px;">
<script type="text/javascript">
<!--
var wParent=opener;
var sqFreeText=eval("wParent."+wParent.spChkItem+".value").replace(new RegExp(String.fromCharCode(8216),"g"),"'");
sqFreeText=sqFreeText.replace(new RegExp(String.fromCharCode(8217),"g"),"'");
sqFreeText=sqFreeText.replace(new RegExp(String.fromCharCode(8220),"g"),"\"");
sqFreeText=sqFreeText.replace(new RegExp(String.fromCharCode(8221),"g"),"\""); 
document.write('<form name="spForm" method="post" action="mSpell.php">\
<input type="hidden" name="setlang" value="<?php echo $lang ?>" />\
<input type="hidden" name="spellLang" value="'+escape(eval("wParent."+wParent.spChkLang+".value"))+'" />\
<input type="hidden" name="spellText" value="" />\
<'+'scrip'+'t type="text/ja'+'vascr'+'ipt">\
document.forms["spForm"].spellText.value=escape(sqFreeText);\
document.forms["spForm"].submit();\
</scr'+'ipt>'+'\
</form>');
//-->
</script>
</body>
</html>
<?php
exit;
}
?>
<script type="text/javascript">
<!--
var wParent=opener;
var msb=wParent.msMode, confAfterRep=true;
var p2=0, ec=0, gL=0, blck=false;
var po=new Array(), g=new Array();
var rep=new Object();

function spellCheckDone(){
alert("<?php echo $l_spellCheckDone ?>");
self.close();
}

function S(p,sw){
this.p=p;
this.sw=sw;
this.w=function (s) { s=new Option(s); this.b[this.c++]=s; }
this.b=new Object();
this.c=0;
this.replaced=false;
}

<?php

function noJobs(){
echo "spellCheckDone();\n//-->\n</script></head></html>";
exit;
}

if($spellLang=='') noJobs();

if($sys=='nix'){
$pspell_config=pspell_config_create($spellLang);
pspell_config_mode($pspell_config,PSPELL_FAST);
$pspell_link=pspell_new_config($pspell_config);
}
else{
$pspell_config=pspell_config_create($spellLang);
pspell_config_personal($pspell_config,$dict_path.$dictAr[$spellLang]);
$pspell_link=pspell_new_personal($pspell_config,$spellLang);
}
$spellText=rawurldecode($_POST['spellText']);
$spellExp=explode(' ',trim(preg_replace($doNotCheck,' ',strip_tags(str_replace(array('<','>'),array(' <','> '),str_replace(array("\n","\r","\t"),' ',preg_replace('/\[[^\]]*\]/','',$spellText)))))));
$r=0;
$pstR='");';
$spExpLn=sizeof($spellExp);
$spellPos=-1;
$sgsLnMax=0;
for($i=0;$i<$spExpLn;$i++){
	$spellExp[$i]=trim($spellExp[$i]);
	if($spellExp[$i]=='') continue;
	$spellPos=strpos($spellText,$spellExp[$i],$spellPos+1);
	if(!pspell_check($pspell_link,$spellExp[$i])){
		echo 'rep['.$r.']=new S('.$spellPos.',"'.$spellExp[$i].'");';
		$preR='rep['.$r.'].w("';
		$sgs=pspell_suggest($pspell_link,$spellExp[$i]);
		echo $preR.implode($pstR.$preR,$sgs).$pstR;
		$sgsLn=sizeof($sgs);
		if($sgsLnMax<$sgsLn) $sgsLnMax=$sgsLn;
		$r++;
	}
}
echo 'ec='.$r.'; var txt=unescape(\''.$_POST['spellText'].'\');';

if($r==0) noJobs();
?>

Array.prototype.inArray=function(value){
var i,dL=this.length;
for(i=0; i<dL; i++) if(this[i]==value) return true;
return false;
}

for(var i=0; i<ec; i++){
var repObj=rep[i];
for(var n=0;n<repObj.c;n++) if(!g.inArray(repObj.b[n].text)) g[gL++]=repObj.b[n].text;
}

function confRep(){
if(confAfterRep) return confirm("<?php echo $l_spellConf1 ?> '"+rep[p2-1].sw+"' <?php echo $l_spellConf2 ?>");
else return true;
}

function blckMessage(){
alert("<?php echo $l_spellCheckBlock ?>");
}

function rez(){
var res=null;
while(p2!=ec){
res=rep[p2++];
if(!vld2(po,res.sw) && !res.replaced) return res;
else res=null;
}
return res;
}

function doSp(){
var repObj=rez();
if(repObj!=null){
for(n=0;n<10;n++){
if(n<repObj.c){
rw.pp.options[n].value=repObj.b[n].text;
rw.pp.options[n].text=repObj.b[n].text;
}
else if(rw.pp.options[n]!=undefined){
rw.pp.options[n].value="";
rw.pp.options[n].text="";
}
}
if(repObj.c>0){
rw.pp.options[0].selected=true;
rw.repWrd.value=repObj.b[0].text;
}
else rw.repWrd.value=repObj.sw;
rw.NA.value=repObj.sw;
if(repObj.c>0 && repObj.b[0].text.charAt(0)=='*'){
rw.repWrd.disabled=true;
blck=true;
rw.ignore.disabled=true;
rw.ignoreAll.disabled=true;
}
else{
if(rw.repWrd.disabled){
blck=false;
rw.repWrd.disabled=false;
rw.ignore.disabled=false;
rw.ignoreAll.disabled=false;
}
}
selRange(repObj);
if(repObj.c>0){
rw.pp.options[0].selected=true;
rw.repWrd.value='';
rw.repWrd.value=repObj.b[0].text;
}
else{
rw.repWrd.value='';
rw.repWrd.value=repObj.sw;
}
rw.NA.value='';
rw.NA.value=repObj.sw;
}
else f10();
}

function selRange(curObj){
var p=curObj.p, lineCount=0, sw=curObj.sw;
for(var n=txt.indexOf("\n",0);n!=-1 && n<p;n=txt.indexOf("\n",n+1)) lineCount++;
var scItem=eval("wParent."+wParent.spChkItem);
if(!msb){
scItem.focus();
scItem.setSelectionRange(p-lineCount,p-lineCount+sw.length);
}
else{
scItem=scItem.createTextRange();
scItem.move("character",p-lineCount);
scItem.moveEnd("character",sw.length);
scItem.select();
}
}

function repl(){
var wrd=rw.repWrd.value;
var validRep=vld1(wrd);
if(!validRep && !confRep()) return;
trunc(p2-1,wrd);
wParent.updElement(txt);
doSp();
}

function replA(){
var wrd=rw.repWrd.value;
var validRep=vld1(wrd);
if(!validRep && !confRep()) return;
for(var i=p2-1;i<ec;i++) if(rep[i].sw==rep[p2-1].sw) trunc(i,wrd);
wParent.updElement(txt);
doSp();
}

function ign(a){
if(!blck){
if(a==1) po[po.length]=rep[p2-1].sw;
doSp();
}
else blckMessage();
}

function upd(){
if(rw.pp.selectedIndex>=rep[p2-1].c) rw.pp.selectedIndex=rep[p2-1].c-1;
if(rw.pp.selectedIndex!=-1) rw.repWrd.value=rw.pp.options[rw.pp.selectedIndex].text;
}

function onChWrd(){
if(rw.pp.selectedIndex!=-1){
upd();
repl();
}
}

function trunc(hg,wrd){
var whichError=rep[hg];
txt=txt.substring(0,whichError.p)+wrd+txt.substring(whichError.p+whichError.sw.length,txt.length);
whichError.replaced=true;
var ro=(wrd.length-whichError.sw.length);
for(var i=hg+1;i<ec;i++) rep[i].p+=ro;
}

function vld1(Z){
for(var i=0;i<gL;i++) if(g[i]==Z) return true;
return false;
}

function vld2(z,Z){
zL=z.length;
for(var i=0;i<zL;i++) if(z[i]==Z) return true;
return false;
}

function f10(){
if(!msb){
var scItem=eval("wParent."+wParent.spChkItem);
scItem.focus();
scItem.setSelectionRange(0,0);
}
else{
var scItem=eval("wParent."+wParent.spChkItem).createTextRange();
scItem.moveStart("textedit",1);
scItem.moveEnd("textedit",1);
scItem.select();
}
spellCheckDone();
}

//-->
</script>
</head>
<body class="gbody popUp">
<form action="" name="spForm" method="post" class="formStyle">
<div align="center">
<table class="spellTable">
<tr>
<td>&nbsp;</td>
<td align="right">
<table class="spellTable">
<tr>
<td class="txtSm"><?php echo $l_spellInvalidWord ?></td>
</tr>
<tr>
<td><input type="text" readonly="readonly" name="NA" size="12" class="textForm" style="width:158px;" /></td>
</tr>
<tr>
<td class="txtSm"><?php echo $l_spellReplaceWith ?></td>
</tr>
<tr>
<td><input type="text" name="repWrd" size="12" class="textForm" style="width:158px;" /></td>
</tr>
<tr>
<td class="txtSm"><?php echo $l_spellSuggestions ?></td>
</tr>
<tr>
<td><select name="pp" class="selectTxt" style="width:158px;" onchange="parent.upd();" ondblclick="parent.onChWrd();" size="5"><option>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</option>
<?php for($i=0;$i<$sgsLnMax;$i++) echo '<option></option>'; ?></select></td>
</tr>
</table>
</td>
<td>&nbsp;</td>
<td>
<input type="button" name="repl" onclick="parent.repl();return false;" class="inputButton" value="<?php echo $l_spellReplace ?>" /><br />
<input type="button" name="replA" onclick="parent.replA();return false;" class="inputButton" value="<?php echo $l_spellReplaceAll ?>" /><br />
<input type="button" name="ign" onclick="parent.ign(0);return false;" class="inputButton" value="<?php echo $l_spellIgnore ?>" /><br />
<input type="button" name="ignA" onclick="parent.ign(1);return false;" class="inputButton" value="<?php echo $l_spellIgnoreAll ?>" /><br />
<p><input type="button" name="f10" onclick="parent.f10();return false;" class="inputButton" value="<?php echo $l_spellCancel ?>" /></p>
</td>
<td>&nbsp;</td>
</tr>
</table>
</div>
</form>
<script type="text/javascript">
<!--
var rw=document.forms['spForm'];
doSp();
//-->
</script>
</body>
</html>